package com.compomics.scripts_marc;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * Creates fake files to work with the PX submission tool
 *
 * @author Marc Vaudel
 */
public class FakeFiles {
    
    public static void main(String[] args) {
        FakeFiles m = new FakeFiles();

        try {
            File destinationFolder = new File("F:\\PRIDE Raw files S1 S2 S3\\FakeFiles");
            destinationFolder.mkdir();
            File originalFolder = new File("F:\\PRIDE Raw files S1 S2 S3\\PRIDE Raw Files S1");
            m.processFolderContent(originalFolder, destinationFolder);
            originalFolder = new File("F:\\PRIDE Raw files S1 S2 S3\\PRIDE Raw Files S2");
            m.processFolderContent(originalFolder, destinationFolder);
            originalFolder = new File("F:\\PRIDE Raw files S1 S2 S3\\PRIDE Raw Files S3");
            m.processFolderContent(originalFolder, destinationFolder);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void processFolderContent(File folder, File destinationFolder) throws IOException {
        for (File file : folder.listFiles()) {
            createFakeFile(file, destinationFolder);
        }
    }
    
    public void createFakeFile(File originalFile, File destinationFolder) throws IOException {
        String fileName = originalFile.getName();
        BufferedWriter bw = new BufferedWriter(new FileWriter(new File(destinationFolder, fileName)));
        bw.write("test");
        bw.close();
    }

}
