package com.compomics.scripts_marc;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

/**
 * Class to use for the grouping of reporter projects
 *
 * @author Marc Vaudel
 */
public class ReporterGrouping {

    private static final String separator = "\t";

    public static void main(String[] args) {
        ReporterGrouping m = new ReporterGrouping();

        try {
            System.out.println("merging peptides");
            m.groupProjectsPeptides();
            System.out.println("merging proteins");
            m.groupProjectsProteins();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void groupProjectsProteins() throws FileNotFoundException, IOException {

        if (true) {
            try {

                File folder = new File("Y:\\Hilde\\Karolinska\\Export");

                int nFiles = 4,
                        nProteins = 20000,
                        nRatios = 4,
                        ratioIndex = 25;
                String[] orderedExperiments = {"Exp1", "Exp2", "Exp3", "Exp4", "Exp5", "Exp6", "Exp7", "Exp8", "Exp9", "Exp10", "Exp11", "Exp12", "Exp13", "Exp14", "Exp15", "Exp16", "Exp17", "Exp18", "Exp19", "Exp20", "Exp21", "Exp22", "Exp23"};
                HashMap<String, String> fileMap = new HashMap<String, String>(nFiles);
                fileMap.put(orderedExperiments[0], "All Proteins Exp1.txt");
                fileMap.put(orderedExperiments[1], "All Proteins Exp2.txt");
                fileMap.put(orderedExperiments[2], "All Proteins Exp3.txt");
                fileMap.put(orderedExperiments[3], "All Proteins Exp4.txt");
                fileMap.put(orderedExperiments[4], "All Proteins Exp5.txt");
                fileMap.put(orderedExperiments[5], "All Proteins Exp6.txt");
                fileMap.put(orderedExperiments[6], "All Proteins Exp7.txt");
                fileMap.put(orderedExperiments[7], "All Proteins Exp8.txt");
                fileMap.put(orderedExperiments[8], "All Proteins Exp9.txt");
                fileMap.put(orderedExperiments[9], "All Proteins Exp10.txt");
                fileMap.put(orderedExperiments[10], "All Proteins Exp11.txt");
                fileMap.put(orderedExperiments[11], "All Proteins Exp12.txt");
                fileMap.put(orderedExperiments[12], "All Proteins Exp13.txt");
                fileMap.put(orderedExperiments[13], "All Proteins Exp14.txt");
                fileMap.put(orderedExperiments[14], "All Proteins Exp15.txt");
                fileMap.put(orderedExperiments[15], "All Proteins Exp16.txt");
                fileMap.put(orderedExperiments[16], "All Proteins Exp17.txt");
                fileMap.put(orderedExperiments[17], "All Proteins Exp18.txt");
                fileMap.put(orderedExperiments[18], "All Proteins Exp19.txt");
                fileMap.put(orderedExperiments[19], "All Proteins Exp20.txt");
                fileMap.put(orderedExperiments[20], "All Proteins Exp21.txt");
                fileMap.put(orderedExperiments[21], "All Proteins Exp22.txt");
                fileMap.put(orderedExperiments[22], "All Proteins Exp23.txt");
                nFiles = fileMap.size();

                HashMap<String, ArrayList<String>> ratios = new HashMap<String, ArrayList<String>>(nFiles);

                HashMap<String, String> keyToMainMatchMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> keyToOtherMatchesMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> groupClassMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> mwMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> descriptionMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> geneMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> chromosomeMap = new HashMap<String, String>(nProteins);
                HashMap<String, String> possibleCoverage = new HashMap<String, String>(nProteins);
                HashMap<String, Integer> decoyMap = new HashMap<String, Integer>(nProteins);

                HashMap<String, ArrayList<String>> proteinKeysMap = new HashMap<String, ArrayList<String>>(nFiles);
                HashMap<String, HashMap<String, Integer>> peptidesMap = new HashMap<String, HashMap<String, Integer>>(nFiles);
                HashMap<String, HashMap<String, Integer>> spectraMap = new HashMap<String, HashMap<String, Integer>>(nFiles);
                HashMap<String, HashMap<String, Integer>> nonEnzymaticMap = new HashMap<String, HashMap<String, Integer>>(nFiles);
                HashMap<String, HashMap<String, Integer>> validatedPeptidesMap = new HashMap<String, HashMap<String, Integer>>(nFiles);
                HashMap<String, HashMap<String, Integer>> uniquePeptidesMap = new HashMap<String, HashMap<String, Integer>>(nFiles);
                HashMap<String, HashMap<String, Integer>> validatedSpectraMap = new HashMap<String, HashMap<String, Integer>>(nFiles);
                HashMap<String, HashMap<String, Double>> coverageMap = new HashMap<String, HashMap<String, Double>>(nFiles);
                HashMap<String, HashMap<String, Double>> nsafMap = new HashMap<String, HashMap<String, Double>>(nFiles);
                HashMap<String, HashMap<String, Double>> pepMap = new HashMap<String, HashMap<String, Double>>(nFiles);
                HashMap<String, HashMap<String, String>> validatedMap = new HashMap<String, HashMap<String, String>>(nFiles);
                HashMap<String, HashMap<String, HashMap<String, Double>>> ratiosMap = new HashMap<String, HashMap<String, HashMap<String, Double>>>(nFiles);

                for (String experiment : orderedExperiments) {

                    System.out.println("    Importing " + experiment);

                    ratios.put(experiment, new ArrayList<String>(nRatios));
                    proteinKeysMap.put(experiment, new ArrayList<String>(nProteins));
                    peptidesMap.put(experiment, new HashMap<String, Integer>(nProteins));
                    spectraMap.put(experiment, new HashMap<String, Integer>(nProteins));
                    nonEnzymaticMap.put(experiment, new HashMap<String, Integer>(nProteins));
                    validatedPeptidesMap.put(experiment, new HashMap<String, Integer>(nProteins));
                    uniquePeptidesMap.put(experiment, new HashMap<String, Integer>(nProteins));
                    validatedSpectraMap.put(experiment, new HashMap<String, Integer>(nProteins));
                    coverageMap.put(experiment, new HashMap<String, Double>(nProteins));
                    nsafMap.put(experiment, new HashMap<String, Double>(nProteins));
                    pepMap.put(experiment, new HashMap<String, Double>(nProteins));
                    validatedMap.put(experiment, new HashMap<String, String>(nProteins));
                    ratiosMap.put(experiment, new HashMap<String, HashMap<String, Double>>(nProteins));

                    String fileName = fileMap.get(experiment);
                    File myFile = new File(folder, fileName);
                    BufferedReader br = new BufferedReader(new FileReader(myFile));

                    try {

                        String line = br.readLine();
                        line = br.readLine();
                        String[] split = line.split(separator);
                        for (int i = ratioIndex; i < split.length; i++) {
                            String value = split[i];
                            ratios.get(experiment).add(value);
                            ratiosMap.get(experiment).put(value, new HashMap<String, Double>());
                        }
                        while ((line = br.readLine()) != null && !line.equals("")) {
                            split = line.split(separator);
                            String key = split[7];
                            keyToMainMatchMap.put(key, split[1]);
                            keyToOtherMatchesMap.put(key, split[6]);
                            groupClassMap.put(key, split[5]);
                            mwMap.put(key, split[15]);
                            descriptionMap.put(key, split[2]);
                            Integer integerValue = new Integer(split[22]);
                            decoyMap.put(key, integerValue);
                            possibleCoverage.put(key, split[24]);
                            geneMap.put(key, split[3]);
                            chromosomeMap.put(key, split[4]);
                            integerValue = new Integer(split[8]);
                            peptidesMap.get(experiment).put(key, integerValue);
                            integerValue = new Integer(split[14]);
                            validatedPeptidesMap.get(experiment).put(key, integerValue);
                            integerValue = new Integer(split[9]);
                            nonEnzymaticMap.get(experiment).put(key, integerValue);
                            integerValue = new Integer(split[10]);
                            uniquePeptidesMap.get(experiment).put(key, integerValue);
                            integerValue = new Integer(split[11]);
                            spectraMap.get(experiment).put(key, integerValue);
                            integerValue = new Integer(split[12]);
                            validatedSpectraMap.get(experiment).put(key, integerValue);
                            Double doubleValue = new Double(split[13]);
                            coverageMap.get(experiment).put(key, doubleValue);
                            doubleValue = new Double(split[16]);
                            nsafMap.get(experiment).put(key, doubleValue);
                            doubleValue = new Double(split[21]);
                            pepMap.get(experiment).put(key, 1 - doubleValue / 100);
                            validatedMap.get(experiment).put(key, split[23]);
                            for (int i = ratioIndex; i < split.length; i++) {
                                int index = i - ratioIndex;
                                String ratioTitle = ratios.get(experiment).get(index);
                                doubleValue = new Double(split[i]);
                                ratiosMap.get(experiment).get(ratioTitle).put(key, doubleValue);
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        throw new IllegalArgumentException("An error occurred while processing the file " + fileName + ".");
                    } finally {
                        br.close();
                    }
                }

                System.out.println("    Estimating FDR");

                int nKeys = keyToMainMatchMap.size();
                HashMap<String, Double> keyToScoreMap = new HashMap<String, Double>(nKeys);
                HashMap<Double, Integer> nDecoy = new HashMap<Double, Integer>();
                HashMap<Double, Integer> nTarget = new HashMap<Double, Integer>();

                for (String key : keyToMainMatchMap.keySet()) {
                    double score = 1;
                    for (String experiment : pepMap.keySet()) {
                        Double pep = pepMap.get(experiment).get(key);
                        if (pep != null) {
                            score *= pep;
                        }
                    }
                    keyToScoreMap.put(key, score);
                    if (!nDecoy.containsKey(score)) {
                        nDecoy.put(score, 0);
                        nTarget.put(score, 0);
                    }
                    if (decoyMap.get(key) == 1) {
                        nDecoy.put(score, nDecoy.get(score) + 1);
                    } else {
                        nTarget.put(score, nTarget.get(score) + 1);
                    }
                }

                ArrayList<Double> scores = new ArrayList<Double>(nDecoy.keySet());
                Collections.sort(scores);
                int nMax = 0, cpt = -1;
                for (Double score : scores) {
                    if (nDecoy.get(score) > 0) {
                        if (cpt > nMax) {
                            nMax = cpt;
                        }
                        if (cpt == -1) {
                            cpt = 0;
                        }
                    }
                    if (cpt != -1) {
                        cpt += nTarget.get(score);
                    }
                }

                HashMap<Double, Double> peps = new HashMap<Double, Double>();
                for (int i = 0; i < scores.size(); i++) {
                    double tempScore, score = scores.get(i);
                    double nt = nTarget.get(score);
                    double nd = nDecoy.get(score);
                    int j = i;
                    double limit = ((double) (nMax - nt)) / 2;
                    while (--j >= 0 && nt < limit) {
                        tempScore = scores.get(j);
                        nt += nTarget.get(tempScore);
                        nd += nDecoy.get(tempScore);
                    }
                    j = i;
                    while (++j < scores.size() && nt < limit) {
                        tempScore = scores.get(j);
                        nt += nTarget.get(tempScore);
                        nd += nDecoy.get(tempScore);
                    }
                    double pep = nd / nt;
                    peps.put(score, pep);
                }

                System.out.println("    Writing results");

                File outputFile = new File(folder, "Proteins Merged.txt");
                BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));

                writer.write(separator + "Main Accession" + separator + "Description" + separator + "Gene Name" + separator + "Chromosome" + separator + "Protein Inference" + separator + "MW [kDa]" + separator + "Other Protein(s) (alphabetical order)" + separator + "Complete Protein Ambiguity Group (alphabetical order)"
                        + separator + "#Peptides");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("#Validated Peptides");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("#Unique");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("#Non Enzymatic");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("#Spectra");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("#Validated Spectra");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("Coverage [%]");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("Possible Coverage [%]" + separator);
                writer.write("Spectrum Counting [NSAF]");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("Confidence [%]");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("score" + separator + "Overall Confidence [%]" + separator + "decoy" + separator + "Validation");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment);
                    for (int i = 0; i < nRatios; i++) {
                        writer.write(separator);
                    }
                }
                writer.newLine();
                writer.write(separator + separator + separator + separator + separator + separator + separator + separator + separator);
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                writer.write(separator);
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                writer.write(separator + separator + separator);
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    for (String ratioName : ratios.get(experiment)) {
                        writer.write(ratioName + separator);
                    }
                }
                writer.newLine();

                int lineNumber = 0;
                for (String key : keyToMainMatchMap.keySet()) {
                    writer.write(++lineNumber + separator);
                    writer.write(keyToMainMatchMap.get(key) + separator);
                    writer.write(descriptionMap.get(key) + separator);
                    writer.write(geneMap.get(key) + separator);
                    writer.write(chromosomeMap.get(key) + separator);
                    writer.write(groupClassMap.get(key) + separator);
                    writer.write(mwMap.get(key) + separator);
                    writer.write(keyToOtherMatchesMap.get(key) + separator);
                    writer.write(key + separator);
                    for (String experiment : orderedExperiments) {
                        Object value = peptidesMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = validatedPeptidesMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = uniquePeptidesMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = nonEnzymaticMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = spectraMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = validatedSpectraMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = coverageMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    writer.write(possibleCoverage.get(key) + separator);
                    for (String experiment : orderedExperiments) {
                        Object value = nsafMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Double value = pepMap.get(experiment).get(key);
                        if (value != null) {
                            value = 100 * (1 - value);
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    double score = keyToScoreMap.get(key);
                    writer.write(score + separator);
                    double pep = peps.get(score);
                    double confidence = 100 * (1 - pep);
                    writer.write(confidence + separator);
                    writer.write(decoyMap.get(key) + separator);
                    for (String experiment : orderedExperiments) {
                        Object value = validatedMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        for (String ratio : ratios.get(experiment)) {
                            Double value = ratiosMap.get(experiment).get(ratio).get(key);
                            if (value != null) {
                                writer.write(value.toString());
                            }
                            writer.write(separator);
                        }
                    }
                    writer.newLine();
                }
                writer.close();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public void groupProjectsPeptides() throws FileNotFoundException, IOException {

        if (true) {
            try {

                File folder = new File("Y:\\Hilde\\Karolinska\\Export");

                int nFiles = 4,
                        nPeptides = 20000,
                        nRatios = 4,
                        ratioIndex = 15;
                String[] orderedExperiments = {"Exp1", "Exp2", "Exp3", "Exp4", "Exp5", "Exp6", "Exp7", "Exp8", "Exp9", "Exp10", "Exp11", "Exp12", "Exp13", "Exp14", "Exp15", "Exp16", "Exp17", "Exp18", "Exp19", "Exp20", "Exp21", "Exp22", "Exp23"};
                HashMap<String, String> fileMap = new HashMap<String, String>(nFiles);
                fileMap.put(orderedExperiments[0], "All Peptides Exp1.txt");
                fileMap.put(orderedExperiments[1], "All Peptides Exp2.txt");
                fileMap.put(orderedExperiments[2], "All Peptides Exp3.txt");
                fileMap.put(orderedExperiments[3], "All Peptides Exp4.txt");
                fileMap.put(orderedExperiments[4], "All Peptides Exp5.txt");
                fileMap.put(orderedExperiments[5], "All Peptides Exp6.txt");
                fileMap.put(orderedExperiments[6], "All Peptides Exp7.txt");
                fileMap.put(orderedExperiments[7], "All Peptides Exp8.txt");
                fileMap.put(orderedExperiments[8], "All Peptides Exp9.txt");
                fileMap.put(orderedExperiments[9], "All Peptides Exp10.txt");
                fileMap.put(orderedExperiments[10], "All Peptides Exp11.txt");
                fileMap.put(orderedExperiments[11], "All Peptides Exp12.txt");
                fileMap.put(orderedExperiments[12], "All Peptides Exp13.txt");
                fileMap.put(orderedExperiments[13], "All Peptides Exp14.txt");
                fileMap.put(orderedExperiments[14], "All Peptides Exp15.txt");
                fileMap.put(orderedExperiments[15], "All Peptides Exp16.txt");
                fileMap.put(orderedExperiments[16], "All Peptides Exp17.txt");
                fileMap.put(orderedExperiments[17], "All Peptides Exp18.txt");
                fileMap.put(orderedExperiments[18], "All Peptides Exp19.txt");
                fileMap.put(orderedExperiments[19], "All Peptides Exp20.txt");
                fileMap.put(orderedExperiments[20], "All Peptides Exp21.txt");
                fileMap.put(orderedExperiments[21], "All Peptides Exp22.txt");
                fileMap.put(orderedExperiments[22], "All Peptides Exp23.txt");
                nFiles = fileMap.size();

                HashMap<String, ArrayList<String>> ratios = new HashMap<String, ArrayList<String>>(nFiles);

                HashMap<String, ArrayList<String>> peptideKeysMap = new HashMap<String, ArrayList<String>>(nFiles);

                HashMap<String, String> keyToProteinsMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> keyToAasBeforeMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> keyToAasAfterMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> keyToSequenceMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> keyToPtmsMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> decoysMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> mcMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> positionMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> uniqueMap = new HashMap<String, String>(nPeptides);
                HashMap<String, String> piMap = new HashMap<String, String>(nPeptides);

                HashMap<String, HashMap<String, String>> validatedSpectraMap = new HashMap<String, HashMap<String, String>>(nFiles);
                HashMap<String, HashMap<String, String>> nSpectraMap = new HashMap<String, HashMap<String, String>>(nFiles);
                HashMap<String, HashMap<String, String>> confidenceMap = new HashMap<String, HashMap<String, String>>(nFiles);
                HashMap<String, HashMap<String, String>> validationMap = new HashMap<String, HashMap<String, String>>(nFiles);

                HashMap<String, HashMap<String, HashMap<String, Double>>> ratiosMap = new HashMap<String, HashMap<String, HashMap<String, Double>>>(nFiles);

                for (String experiment : orderedExperiments) {

                    System.out.println("    Importing " + experiment);

                    ratios.put(experiment, new ArrayList<String>(nRatios));
                    peptideKeysMap.put(experiment, new ArrayList<String>(nPeptides));

                    validatedSpectraMap.put(experiment, new HashMap<String, String>(nPeptides));
                    nSpectraMap.put(experiment, new HashMap<String, String>(nPeptides));
                    confidenceMap.put(experiment, new HashMap<String, String>(nPeptides));
                    validationMap.put(experiment, new HashMap<String, String>(nPeptides));

                    ratiosMap.put(experiment, new HashMap<String, HashMap<String, Double>>(nPeptides));

                    String fileName = fileMap.get(experiment);
                    File myFile = new File(folder, fileName);
                    BufferedReader br = new BufferedReader(new FileReader(myFile));

                    try {

                        String line = br.readLine();
                        line = br.readLine();
                        String[] split = line.split(separator);
                        for (int i = ratioIndex; i < ratioIndex + nRatios; i++) {
                            String value = split[i];
                            ratios.get(experiment).add(value);
                            ratiosMap.get(experiment).put(value, new HashMap<String, Double>());
                        }
                        while ((line = br.readLine()) != null && !line.equals("")) {

                            split = line.split(separator);
                            String key = split[4] + separator + split[5];

                            keyToProteinsMap.put(key, split[1]);
                            keyToAasBeforeMap.put(key, split[2]);
                            keyToAasAfterMap.put(key, split[3]);
                            keyToSequenceMap.put(key, split[4]);
                            keyToPtmsMap.put(key, split[5]);
                            validatedSpectraMap.get(experiment).put(key, split[6]);
                            nSpectraMap.get(experiment).put(key, split[7]);
                            confidenceMap.get(experiment).put(key, split[8]);
                            decoysMap.put(key, split[9]);
                            validationMap.get(experiment).put(key, split[10]);
                            mcMap.put(key, split[11]);
                            positionMap.put(key, split[12]);
                            uniqueMap.put(key, split[13]);
                            piMap.put(key, split[14]);
                            for (int i = ratioIndex; i < ratioIndex + nRatios; i++) {
                                int index = i - ratioIndex;
                                String ratioTitle = ratios.get(experiment).get(index);
                                Double doubleValue = new Double(split[i]);
                                ratiosMap.get(experiment).get(ratioTitle).put(key, doubleValue);
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        throw new IllegalArgumentException("An error occurred while processing the file " + fileName + ".");
                    } finally {
                        br.close();
                    }
                }

                System.out.println("    Estimating FDR");

                int nKeys = keyToProteinsMap.size();
                HashMap<String, Double> keyToScoreMap = new HashMap<String, Double>(nKeys);
                HashMap<Double, Integer> nDecoy = new HashMap<Double, Integer>();
                HashMap<Double, Integer> nTarget = new HashMap<Double, Integer>();

                for (String key : keyToProteinsMap.keySet()) {
                    double score = 1;
                    for (String experiment : confidenceMap.keySet()) {
                        String confidenceAsString = confidenceMap.get(experiment).get(key);
                        if (confidenceAsString != null) {
                            Double confidence = new Double(confidenceAsString);
                            Double pep = 1 - (confidence / 100);
                            score *= pep;
                        }
                    }
                    keyToScoreMap.put(key, score);
                    if (!nDecoy.containsKey(score)) {
                        nDecoy.put(score, 0);
                        nTarget.put(score, 0);
                    }
                    if (decoysMap.get(key).equals("1")) {
                        nDecoy.put(score, nDecoy.get(score) + 1);
                    } else {
                        nTarget.put(score, nTarget.get(score) + 1);
                    }
                }

                ArrayList<Double> scores = new ArrayList<Double>(nDecoy.keySet());
                Collections.sort(scores);
                int nMax = 0, cpt = -1;
                for (Double score : scores) {
                    if (nDecoy.get(score) > 0) {
                        if (cpt > nMax) {
                            nMax = cpt;
                        }
                        if (cpt == -1) {
                            cpt = 0;
                        }
                    }
                    if (cpt != -1) {
                        cpt += nTarget.get(score);
                    }
                }

                HashMap<Double, Double> peps = new HashMap<Double, Double>();
                for (int i = 0; i < scores.size(); i++) {
                    double tempScore, score = scores.get(i);
                    double nt = nTarget.get(score);
                    double nd = nDecoy.get(score);
                    int j = i;
                    double limit = ((double) (nMax - nt)) / 2;
                    while (--j >= 0 && nt < limit) {
                        tempScore = scores.get(j);
                        nt += nTarget.get(tempScore);
                        nd += nDecoy.get(tempScore);
                    }
                    j = i;
                    while (++j < scores.size() && nt < limit) {
                        tempScore = scores.get(j);
                        nt += nTarget.get(tempScore);
                        nd += nDecoy.get(tempScore);
                    }
                    double pep = nd / nt;
                    peps.put(score, pep);
                }

                System.out.println("    Writing results");

                File outputFile = new File(folder, "Peptides Merged.txt");
                BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));

                writer.write(separator + "Protein(s)" + separator + "AAs Before" + separator + "AAs After" + separator + "Sequence" + separator + "Variable Modifications" + separator + "Missed Cleavages" + separator + "Position in Protein" + separator + "Unique"
                        + separator + "Protein Inference" + separator);
                writer.write("#Validated PSMs");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("#PSMs");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("Confidence");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("Validation");
                for (int i = 0; i < nFiles; i++) {
                    writer.write(separator);
                }
                writer.write("Decoy" + separator + "Score" + separator + "Overall Confidence" + separator);
                for (String experiment : orderedExperiments) {
                    writer.write(experiment);
                    for (int i = 0; i < nRatios; i++) {
                        writer.write(separator);
                    }
                }
                writer.newLine();
                writer.write(separator + separator + separator + separator + separator + separator + separator + separator + separator + separator);
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                for (String experiment : orderedExperiments) {
                    writer.write(experiment + separator);
                }
                writer.write(separator);
                writer.write(separator);
                writer.write(separator);
                for (String experiment : orderedExperiments) {
                    for (String ratioName : ratios.get(experiment)) {
                        writer.write(ratioName + separator);
                    }
                }
                writer.newLine();

                int lineNumber = 0;
                for (String key : keyToProteinsMap.keySet()) {
                    writer.write(++lineNumber + separator);
                    writer.write(keyToProteinsMap.get(key) + separator);
                    writer.write(keyToAasBeforeMap.get(key) + separator);
                    writer.write(keyToAasAfterMap.get(key) + separator);
                    writer.write(keyToSequenceMap.get(key) + separator);
                    writer.write(keyToPtmsMap.get(key) + separator);
                    writer.write(mcMap.get(key) + separator);
                    writer.write(positionMap.get(key) + separator);
                    writer.write(uniqueMap.get(key) + separator);
                    writer.write(piMap.get(key) + separator);
                    for (String experiment : orderedExperiments) {
                        Object value = validatedSpectraMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = nSpectraMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = confidenceMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    for (String experiment : orderedExperiments) {
                        Object value = validationMap.get(experiment).get(key);
                        if (value != null) {
                            writer.write(value.toString());
                        }
                        writer.write(separator);
                    }
                    writer.write(decoysMap.get(key) + separator);
                    double score = keyToScoreMap.get(key);
                    writer.write(score + separator);
                    double pep = peps.get(score);
                    double confidence = 100 * (1 - pep);
                    writer.write(confidence + separator);
                    for (String experiment : orderedExperiments) {
                        for (String ratio : ratios.get(experiment)) {
                            Double value = ratiosMap.get(experiment).get(ratio).get(key);
                            if (value != null) {
                                writer.write(value.toString());
                            }
                            writer.write(separator);
                        }
                    }
                    writer.newLine();
                }
                writer.close();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

}
