package com.compomics.scripts_marc;

import com.compomics.util.experiment.biology.taxonomy.SpeciesFactory;
import com.compomics.util.experiment.biology.taxonomy.mappings.EnsemblSpecies;
import com.compomics.util.experiment.biology.taxonomy.mappings.UniprotTaxonomy;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;

/**
 * Downloads the uniprot species
 *
 * @author Marc Vaudel
 */
public class UniprotSpecies {

    public static void main(String[] args) {

        UniprotSpecies m = new UniprotSpecies();

        try {
            m.getFile();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void getFile() throws FileNotFoundException, IOException {

        File input = new File("D:\\projects\\species\\" + SpeciesFactory.ENSEMBL_SPECIES);
        EnsemblSpecies ensemblSpecies = new EnsemblSpecies();
        ensemblSpecies.loadMapping(input);

        File output = new File("D:\\projects\\species\\" + SpeciesFactory.UNIPROT_TAXONOMY_FILENAME);
        UniprotTaxonomy uniprotTaxonomy = new UniprotTaxonomy();
        uniprotTaxonomy.loadMapping(output);

        for (Integer taxon : ensemblSpecies.getTaxons()) {
            String species = ensemblSpecies.getScientificName(taxon);
            uniprotTaxonomy.downloadMapping(species);
        }

    }
}
